# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: systems@rusticisoftware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ImportFetchRequestSchema(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'url': 'str',
        'content_type': 'str',
        'media_file_metadata': 'MediaFileMetadataSchema'
    }

    attribute_map = {
        'url': 'url',
        'content_type': 'contentType',
        'media_file_metadata': 'mediaFileMetadata'
    }

    def __init__(self, url=None, content_type='application/zip', media_file_metadata=None):  # noqa: E501
        """ImportFetchRequestSchema - a model defined in Swagger"""  # noqa: E501

        self._url = None
        self._content_type = None
        self._media_file_metadata = None
        self.discriminator = None

        self.url = url
        if content_type is not None:
            self.content_type = content_type
        if media_file_metadata is not None:
            self.media_file_metadata = media_file_metadata

    @property
    def url(self):
        """Gets the url of this ImportFetchRequestSchema.  # noqa: E501

        URL path to the .zip package or media file to download to import this course  # noqa: E501

        :return: The url of this ImportFetchRequestSchema.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this ImportFetchRequestSchema.

        URL path to the .zip package or media file to download to import this course  # noqa: E501

        :param url: The url of this ImportFetchRequestSchema.  # noqa: E501
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def content_type(self):
        """Gets the content_type of this ImportFetchRequestSchema.  # noqa: E501

        MIME type of the content to be fetched  # noqa: E501

        :return: The content_type of this ImportFetchRequestSchema.  # noqa: E501
        :rtype: str
        """
        return self._content_type

    @content_type.setter
    def content_type(self, content_type):
        """Sets the content_type of this ImportFetchRequestSchema.

        MIME type of the content to be fetched  # noqa: E501

        :param content_type: The content_type of this ImportFetchRequestSchema.  # noqa: E501
        :type: str
        """

        self._content_type = content_type

    @property
    def media_file_metadata(self):
        """Gets the media_file_metadata of this ImportFetchRequestSchema.  # noqa: E501

        :return: The media_file_metadata of this ImportFetchRequestSchema.  # noqa: E501
        :rtype: MediaFileMetadataSchema
        """
        return self._media_file_metadata

    @media_file_metadata.setter
    def media_file_metadata(self, media_file_metadata):
        """Sets the media_file_metadata of this ImportFetchRequestSchema.

        :param media_file_metadata: The media_file_metadata of this ImportFetchRequestSchema.  # noqa: E501
        :type: MediaFileMetadataSchema
        """

        self._media_file_metadata = media_file_metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ImportFetchRequestSchema, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ImportFetchRequestSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
