# coding: utf-8

"""
    SCORM Cloud Rest API

    REST API used for SCORM Cloud integrations.  # noqa: E501

    OpenAPI spec version: 2.0
    Contact: systems@rusticisoftware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UpdateDispatchSchema(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'allow_new_registrations': 'bool',
        'instanced': 'bool',
        'registration_cap': 'int',
        'registration_count': 'int',
        'expiration_date': 'datetime',
        'enabled': 'bool',
        'email': 'str',
        'notes': 'str',
        'post_back': 'PostBackSchema'
    }

    attribute_map = {
        'allow_new_registrations': 'allowNewRegistrations',
        'instanced': 'instanced',
        'registration_cap': 'registrationCap',
        'registration_count': 'registrationCount',
        'expiration_date': 'expirationDate',
        'enabled': 'enabled',
        'email': 'email',
        'notes': 'notes',
        'post_back': 'postBack'
    }

    def __init__(self, allow_new_registrations=None, instanced=None, registration_cap=None, registration_count=None, expiration_date=None, enabled=None, email=None, notes=None, post_back=None):  # noqa: E501
        """UpdateDispatchSchema - a model defined in Swagger"""  # noqa: E501

        self._allow_new_registrations = None
        self._instanced = None
        self._registration_cap = None
        self._registration_count = None
        self._expiration_date = None
        self._enabled = None
        self._email = None
        self._notes = None
        self._post_back = None
        self.discriminator = None

        if allow_new_registrations is not None:
            self.allow_new_registrations = allow_new_registrations
        if instanced is not None:
            self.instanced = instanced
        if registration_cap is not None:
            self.registration_cap = registration_cap
        if registration_count is not None:
            self.registration_count = registration_count
        if expiration_date is not None:
            self.expiration_date = expiration_date
        if enabled is not None:
            self.enabled = enabled
        if email is not None:
            self.email = email
        if notes is not None:
            self.notes = notes
        if post_back is not None:
            self.post_back = post_back

    @property
    def allow_new_registrations(self):
        """Gets the allow_new_registrations of this UpdateDispatchSchema.  # noqa: E501

        If true, then new registrations can be created for this dispatch.   # noqa: E501

        :return: The allow_new_registrations of this UpdateDispatchSchema.  # noqa: E501
        :rtype: bool
        """
        return self._allow_new_registrations

    @allow_new_registrations.setter
    def allow_new_registrations(self, allow_new_registrations):
        """Sets the allow_new_registrations of this UpdateDispatchSchema.

        If true, then new registrations can be created for this dispatch.   # noqa: E501

        :param allow_new_registrations: The allow_new_registrations of this UpdateDispatchSchema.  # noqa: E501
        :type: bool
        """

        self._allow_new_registrations = allow_new_registrations

    @property
    def instanced(self):
        """Gets the instanced of this UpdateDispatchSchema.  # noqa: E501

        If true, then a new registration instance will be created if the client LMS doesn't provide launch data for an existing one. Otherwise, the same instance will always be used for the given cmi.learner_id.   # noqa: E501

        :return: The instanced of this UpdateDispatchSchema.  # noqa: E501
        :rtype: bool
        """
        return self._instanced

    @instanced.setter
    def instanced(self, instanced):
        """Sets the instanced of this UpdateDispatchSchema.

        If true, then a new registration instance will be created if the client LMS doesn't provide launch data for an existing one. Otherwise, the same instance will always be used for the given cmi.learner_id.   # noqa: E501

        :param instanced: The instanced of this UpdateDispatchSchema.  # noqa: E501
        :type: bool
        """

        self._instanced = instanced

    @property
    def registration_cap(self):
        """Gets the registration_cap of this UpdateDispatchSchema.  # noqa: E501

        The maximum number of registrations that can be created for this dispatch, where '0' means 'unlimited registrations'.   # noqa: E501

        :return: The registration_cap of this UpdateDispatchSchema.  # noqa: E501
        :rtype: int
        """
        return self._registration_cap

    @registration_cap.setter
    def registration_cap(self, registration_cap):
        """Sets the registration_cap of this UpdateDispatchSchema.

        The maximum number of registrations that can be created for this dispatch, where '0' means 'unlimited registrations'.   # noqa: E501

        :param registration_cap: The registration_cap of this UpdateDispatchSchema.  # noqa: E501
        :type: int
        """

        self._registration_cap = registration_cap

    @property
    def registration_count(self):
        """Gets the registration_count of this UpdateDispatchSchema.  # noqa: E501

        The current number of registrations that have been created for this dispatch.   # noqa: E501

        :return: The registration_count of this UpdateDispatchSchema.  # noqa: E501
        :rtype: int
        """
        return self._registration_count

    @registration_count.setter
    def registration_count(self, registration_count):
        """Sets the registration_count of this UpdateDispatchSchema.

        The current number of registrations that have been created for this dispatch.   # noqa: E501

        :param registration_count: The registration_count of this UpdateDispatchSchema.  # noqa: E501
        :type: int
        """

        self._registration_count = registration_count

    @property
    def expiration_date(self):
        """Gets the expiration_date of this UpdateDispatchSchema.  # noqa: E501

        The ISO 8601 TimeStamp (defaults to UTC) after which this dispatch will be disabled. An empty value will represent no expiration date.   # noqa: E501

        :return: The expiration_date of this UpdateDispatchSchema.  # noqa: E501
        :rtype: datetime
        """
        return self._expiration_date

    @expiration_date.setter
    def expiration_date(self, expiration_date):
        """Sets the expiration_date of this UpdateDispatchSchema.

        The ISO 8601 TimeStamp (defaults to UTC) after which this dispatch will be disabled. An empty value will represent no expiration date.   # noqa: E501

        :param expiration_date: The expiration_date of this UpdateDispatchSchema.  # noqa: E501
        :type: datetime
        """

        self._expiration_date = expiration_date

    @property
    def enabled(self):
        """Gets the enabled of this UpdateDispatchSchema.  # noqa: E501

        If true, then this dispatch can be launched.   # noqa: E501

        :return: The enabled of this UpdateDispatchSchema.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this UpdateDispatchSchema.

        If true, then this dispatch can be launched.   # noqa: E501

        :param enabled: The enabled of this UpdateDispatchSchema.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def email(self):
        """Gets the email of this UpdateDispatchSchema.  # noqa: E501

        SCORM Cloud user e-mail associated with this dispatch. If this is not provided, it will default to the owner of the Realm.   # noqa: E501

        :return: The email of this UpdateDispatchSchema.  # noqa: E501
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email):
        """Sets the email of this UpdateDispatchSchema.

        SCORM Cloud user e-mail associated with this dispatch. If this is not provided, it will default to the owner of the Realm.   # noqa: E501

        :param email: The email of this UpdateDispatchSchema.  # noqa: E501
        :type: str
        """

        self._email = email

    @property
    def notes(self):
        """Gets the notes of this UpdateDispatchSchema.  # noqa: E501

        Any provided notes about this dispatch.  # noqa: E501

        :return: The notes of this UpdateDispatchSchema.  # noqa: E501
        :rtype: str
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this UpdateDispatchSchema.

        Any provided notes about this dispatch.  # noqa: E501

        :param notes: The notes of this UpdateDispatchSchema.  # noqa: E501
        :type: str
        """

        self._notes = notes

    @property
    def post_back(self):
        """Gets the post_back of this UpdateDispatchSchema.  # noqa: E501

        The postback information for this Dispatch.  # noqa: E501

        :return: The post_back of this UpdateDispatchSchema.  # noqa: E501
        :rtype: PostBackSchema
        """
        return self._post_back

    @post_back.setter
    def post_back(self, post_back):
        """Sets the post_back of this UpdateDispatchSchema.

        The postback information for this Dispatch.  # noqa: E501

        :param post_back: The post_back of this UpdateDispatchSchema.  # noqa: E501
        :type: PostBackSchema
        """

        self._post_back = post_back

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateDispatchSchema, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateDispatchSchema):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
